package eu.eudat.data.entities;


import eu.eudat.queryable.queryableentity.DataEntity;
import org.hibernate.annotations.GenericGenerator;
import org.hibernate.annotations.Type;

import javax.persistence.*;
import java.util.Date;
import java.util.Set;
import java.util.UUID;


@Entity
@Table(name = "\"DatasetProfile\"")
public class DatasetProfile implements DataEntity<DatasetProfile,UUID> {

    @Id
    @GeneratedValue
    @GenericGenerator(name = "uuid2", strategy = "uuid2")
    @Column(name = "\"ID\"", updatable = false, nullable = false, columnDefinition = "BINARY(16)")
    private UUID id;

    @Column(name = "\"Label\"")
    private String label;

    @OneToMany(fetch = FetchType.LAZY, mappedBy = "profile")
    private Set<Dataset> dataset;

    @Type(type = "eu.eudat.configurations.typedefinition.XMLType")
    @Column(name = "\"Definition\"", columnDefinition = "xml", nullable = false)
    private String definition;


    @Column(name = "\"Status\"", nullable = false)
    private Short status;


    @Column(name = "\"Created\"")
    private Date created;

    @Column(name = "\"Modified\"")
    private Date modified = new Date();

    @Column(name = "\"Description\"")
    private String description;


    public String getDescription() {
        return description;
    }


    public void setDescription(String description) {
        this.description = description;
    }


    public Short getStatus() {
        return status;
    }


    public void setStatus(Short status) {
        this.status = status;
    }


    public Date getCreated() {
        return created;
    }


    public void setCreated(Date created) {
        this.created = created;
    }


    public Date getModified() {
        return modified;
    }


    public void setModified(Date modified) {
        this.modified = modified;
    }


    public UUID getId() {
        return id;
    }

    public void setId(UUID id) {
        this.id = id;
    }

    public String getLabel() {
        return label;
    }

    public void setLabel(String label) {
        this.label = label;
    }


    public String getDefinition() {
        return definition;
    }

    public void setDefinition(String definition) {
        this.definition = definition;
    }


    public Set<Dataset> getDataset() {
        return dataset;
    }

    public void setDataset(Set<Dataset> dataset) {
        this.dataset = dataset;
    }

    @Override
    public String toString() {
        return "DatasetProfileListingModel [id=" + id + ", label=" + label + ", dataset=" + dataset + ", definition=" + definition + "]";
    }


    @Override
    public void update(DatasetProfile entity) {

    }

    @Override
    public UUID getKeys() {
        return this.id;
    }
}
