package eu.eudat.logic.services.utilities;

import eu.eudat.models.data.mail.SimpleMail;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.core.env.Environment;
import org.springframework.mail.SimpleMailMessage;
import org.springframework.mail.javamail.JavaMailSender;
import org.springframework.stereotype.Service;


@Service("mailService")
public class MailServiceImpl implements MailService {
    @Autowired
    private Environment env;

    @Autowired
    private JavaMailSender emailSender;

    @Override
    public void sendSimpleMail(SimpleMail mail) {
        SimpleMailMessage message = new SimpleMailMessage();
        message.setSubject(mail.getSubject());
        message.setText(mail.getContent());
        message.setTo(mail.getTo());
        message.setFrom(env.getProperty("mail.from"));
        this.emailSender.send(message);
    }

    public Environment getEnv() {
        return env;
    }

    @Override
    public String getMailTemplateContent() {
        return env.getProperty("mail.content");
    }

    @Override
    public String getMailTemplateSubject() {
        return env.getProperty("mail.subject");
    }
}
