package eu.eudat.models.data.dataset;

import eu.eudat.models.DataModel;
import eu.eudat.logic.utilities.helpers.LabelGenerator;

import java.util.Date;

public class DataRepository implements DataModel<eu.eudat.data.entities.DataRepository, DataRepository>, LabelGenerator {
    private String pid;
    private String name;
    private String uri;
    private String info;

    public String getPid() {
        return pid;
    }

    public void setPid(String pid) {
        this.pid = pid;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getUri() {
        return uri;
    }

    public void setUri(String uri) {
        this.uri = uri;
    }

    public String getInfo() {
        return info;
    }

    public void setInfo(String info) {
        this.info = info;
    }

    public DataRepository fromDataModel(eu.eudat.data.entities.DataRepository entity) {
        this.pid = entity.getReference();
        this.name = entity.getLabel();
        this.uri = entity.getUri();
        return this;
    }

    public eu.eudat.data.entities.DataRepository toDataModel() {
        eu.eudat.data.entities.DataRepository entity = new eu.eudat.data.entities.DataRepository();
        entity.setReference(this.pid);
        entity.setLabel(this.name);
        entity.setUri(this.uri);
        entity.setCreated(new Date());
        entity.setModified(new Date());
        entity.setStatus((short) 0);
        return entity;
    }

    @Override
    public String generateLabel() {
        return this.getName();
    }

    @Override
    public String getHint() {
        return null;
    }
}
