import { DatasetWizardComponent } from './dataset-wizard/dataset-wizard.component';
import { DatasetListingComponent } from './listing/dataset-listing.component';
import { RouterModule, Routes } from '@angular/router';
import { AuthGuard } from '../shared/guards/auth.guard';

export const DatasetRoutes: Routes = [
  {
    path: "new/:dmpId",
    component: DatasetWizardComponent,
    canActivate: [AuthGuard],
    data: {
      breadcrumb: true
    },
  },
  {
    path: "edit/:id",
    component: DatasetWizardComponent,
    canActivate: [AuthGuard],
    data: {
      breadcrumb: true
    },
  },
  {
    path: "new",
    component: DatasetWizardComponent,
    canActivate: [AuthGuard],
    data: {
      breadcrumb: true
    },
  },
  {
    path: '',
    component: DatasetListingComponent,
    canActivate: [AuthGuard],
    data: {
      breadcrumb: true
    },
  },
  {
    path: "dmp/:dmpId",
    component: DatasetListingComponent,
    canActivate: [AuthGuard],
    data: {
      breadcrumb: true
    },
  }
];
