import { Serializable } from "../Serializable";
import { FormGenerator } from "../interfaces/FormGenerator";
import { FormGroup, FormBuilder } from "@angular/forms";

export class DynamicFieldDependency implements Serializable<DynamicFieldDependency>, FormGenerator<FormGroup>{
    public id: string
    public queryProperty: string

    fromJSONObject(item: any): DynamicFieldDependency {
        this.id = item.id;
        this.queryProperty = item.queryProperty;
        return this;
    }

    buildForm(): FormGroup {
        return new FormBuilder().group({
            id: [this.id],
            queryProperty: [this.queryProperty]
        })
    }
}