import { Serializable } from "../Serializable";
import { ValidationContext } from "../../utilities/validators/ValidationContext";
import { FormBuilder, FormGroup } from "@angular/forms";

export class DataRepositoryModel implements Serializable<DataRepositoryModel> {
  public id: String;
  public name: String;
  public pid: String;
  public uri: String;
  public info: String;

  constructor(id?: String, name?: String, pid?: String, uri?: String, info?: String
  ) {
    this.id = id;
    this.name = name;
    this.pid = pid;
    this.uri = uri;
    this.info = info;
  }
  fromJSONObject(item: any): DataRepositoryModel {
    this.id = item.id;
    this.name = item.name;
    this.pid = item.pid;
    this.uri = item.uri;
    this.info = item.info;
    return this;
  }

  buildForm(context: ValidationContext = null, disabled: boolean = false): FormGroup {
    return new FormBuilder().group({
      id: [this.id],
      name: [this.name],
      pid: [this.pid],
      uri: [this.uri],
      info: [this.info]
    })
  }
}
