import { JsonSerializer } from '../../../utilities/JsonSerializer';
import { UserInvitationCriteria } from '../../../models/criteria/invitation/UserInvitationCriteria';
import { RequestItem } from '../../../models/criteria/RequestItem';
import { Invitation } from '../../../models/invitation/Invitation';
import { InvitationService } from '../../../services/invitation/invitation.service';
import { User } from '../../../models/invitation/User';
import { Component, OnInit, Inject } from "@angular/core";
import { FormGroup } from '@angular/forms';
import { Params, ActivatedRoute, Router } from '@angular/router';
import { MAT_DIALOG_DATA } from '@angular/material';

@Component({
  selector: 'app-invitation-accepted-component',
  templateUrl: 'invitation-accepted.component.html',

})
export class InvitationAcceptedComponent implements OnInit {
  constructor(
    private invitationService: InvitationService,
    private route: ActivatedRoute,
    public router: Router
  ) { }

  ngOnInit(): void {
    this.route.params.subscribe(params => {
      let id = params["id"]
      this.invitationService.exchange(id).subscribe(id => {
        this.router.navigate(["dmps/edit/" + id])
      })
    }
    )
  }
}
