import { Component, Input } from "@angular/core";
import { UrlListingItem } from "../../../shared/components/url-listing/UrlListingItem";
import { Router } from "@angular/router";
import { UrlUtilities } from "../../../utilities/UrlUtilities";

@Component({
  selector: 'app-url-listing',
  templateUrl: './url-listing.component.html'
})
export class UrlListingComponent {

  @Input()
  items: UrlListingItem[];

  @Input()
  parameters: any

  @Input()
  urlLimit: number = 3;

  constructor(private router: Router, private urlUtilities: UrlUtilities) { }

  ngOnInit() {

  }

  navigate(link: string) {
    this.router.navigate([link, this.parameters]);
  }
}
