import { BaseCriteriaComponent } from './components/criteria/base/base-criteria.component';
import { FigurecardComponent } from './components/figurecard/figurecard.component';
import { AutocompleteComponent } from './components/autocomplete/autocomplete.component';
import { CommonModule } from '@angular/common';
import { FlexLayoutModule } from '@angular/flex-layout';

import { NgModule } from '@angular/core';
import { RouterModule } from '@angular/router';
import { NavigationComponent } from './components/navigation/navigation.component';
import { SnackBarNotificationComponent } from './components/notificaiton/snack-bar-notification.component';
import { MaterialModule } from './material/material.module';
import { TranslateModule } from '@ngx-translate/core';
import { ProjectCriteriaComponent } from './components/criteria/projects/projects-criteria.component';
import { DatasetCriteriaComponent } from './components/criteria/datasets/datasets-criteria.component';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { DataManagementPlanCriteriaComponent } from './components/criteria/data-management-plan/dmp-criteria.component';
import { AutocompleteChipComponent } from '../shared/components/autocompleteChips/autocompleteChips.component';
import { FileUploaderComponent } from '../shared/components/file-uploader/file-uploader.component';
import { UrlListingComponent } from '../shared/components/url-listing/url-listing.component';
import { NgForLimitPipe } from './pipes/ngforlimit/ngforlimit.pipe';
import { DataManagementPlanProfileCriteriaComponent } from './components/criteria/datamanagementplanprofile/dmp-profile-criteria.component';
import { AutoCompleteComponent } from './components/auto-complete/auto-complete.component';
import { ExternalItemListingComponent } from './components/external-items/external-item-listing/external-item-listing.component';
import { ExternalItemComponent } from './components/external-items/external-item/external-item.component';
import { BreadcrumbComponent } from './components/breadcrumb/breadcrumb.component';

@NgModule({
  imports: [
    CommonModule,
    RouterModule,
    MaterialModule,
    FlexLayoutModule,
    TranslateModule,
    FormsModule,
    ReactiveFormsModule
  ],

  declarations: [
    NavigationComponent,
    SnackBarNotificationComponent,
    ProjectCriteriaComponent,
    DatasetCriteriaComponent,
    DataManagementPlanCriteriaComponent,
    DataManagementPlanProfileCriteriaComponent,
    AutocompleteComponent,
    FigurecardComponent,
    BaseCriteriaComponent,
    FileUploaderComponent,
    AutocompleteChipComponent,
    UrlListingComponent,
    NgForLimitPipe,
    AutoCompleteComponent,
    ExternalItemListingComponent,
    ExternalItemComponent,
    BreadcrumbComponent

  ],

  exports: [
    MaterialModule,
    FlexLayoutModule,

    NavigationComponent,
    SnackBarNotificationComponent,
    ProjectCriteriaComponent,
    DatasetCriteriaComponent,
    DataManagementPlanProfileCriteriaComponent,
    DataManagementPlanCriteriaComponent,
    AutocompleteComponent,
    FigurecardComponent,
    BaseCriteriaComponent,
    FileUploaderComponent,
    AutocompleteChipComponent,
    UrlListingComponent,
    NgForLimitPipe,
    AutoCompleteComponent,
    ExternalItemListingComponent,
    ExternalItemComponent,
    BreadcrumbComponent
  ],
  entryComponents: [
  ]
})

export class SharedModule { }
