import { Component, OnInit } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { DashboardService } from '../../app/services/dashboard/dashboard.service';
import { DashboardStatisticsModel } from '../models/dashboard/DashboardStatisticsModel';
import { JsonSerializer } from '../utilities/JsonSerializer';
import { HomepageComponent } from '../homepage/homepage.component'
import { IBreadcrumb } from 'ngx-breadcrumbs';
import { IBreadCrumbComponent } from '../shared/components/breadcrumb/definition/IBreadCrumbComponent';
import { Observable } from 'rxjs/Observable';
import { BreadcrumbItem } from '../shared/components/breadcrumb/definition/breadcrumb-item';

@Component({
  selector: 'welcomepage',
  templateUrl: './welcomepage.component.html',
  // styleUrls: ['./homepage.component.css'],
  providers: [DashboardService]
})
export class WelcomepageComponent implements OnInit, IBreadCrumbComponent {

  breadCrumbs: Observable<BreadcrumbItem[]> = Observable.of([]);
  private userInfo: any;
  private dashboardStatisticsData: DashboardStatisticsModel = new DashboardStatisticsModel();

  constructor() {
  }

  ngOnInit() {
    this.breadCrumbs = Observable.of([{ parentComponentName: null, label: 'Home', url: "/welcome" }])
  }

}
